; debounce.asm
;
; Utilizza Porta A come uscita
; Porta C come ingresso (intera)
; Configurazione:
; 1000 1011
;
;	R0	Tasti in ingresso
;	R1	Vecchi Tasti
;	R2	Contatore debounce
;	R3	Stato LED
;
	.org	8050h
;
;	Programmo modo
;
	MOV	DPTR,#0FA03h	; Porta di controllo
	MOV	A,#10001011B	; Impostazioni
	MOVX	@DPTR,A		; Scarica le impostazioni sulla scheda
	MOV	R1,#0		; Tasti rilasciati
	MOV	R3,#0ffh	; LED Spenti
	MOV	A,R3
	MOV	DPTR,#0FA00H	; Porta A
	MOVX	@DPTR,A		; Imposta i LED
;
mainloop:
	MOV	DPTR,#0FA02H	; Porta C
intest:
	MOVX	A,@DPTR		; Legge Tasti
	CPL	A		; Inverte il livello (Premuto = 1)
	MOV	R0,A		; Mette via valore corrente
	XRL	A,R1		; Rileva cambiamento
	JZ	intest		; Se non è cambiato, aspetta
debounce:
	MOVX	A,@DPTR		; Legge Tasti
	CPL	A		; Inverte il livello (Premuto = 1)
	MOV	R0,A		; Mette via valore corrente
	mov	R2,#0		; inizializza conteggio
debloop:
	MOVX	A,@DPTR		; Rilegge Input
	CPL	A
	XRL	A,R0		; Cambiato?
	JNZ	debounce	; Si, ricomincia
	DJNZ	R2,debloop	; Riprova N volte;
;
; Fine debounce
;
	MOV	A,R0		; Recupera Valore
	XRL	A,R1		; Guarda cosa e' cambiato
	ANL	A,R0		; Solo quelli a 1
	XRL	A,R3		; Commuta i LED
	MOV	R3,A		; Rimette via
	MOV	DPTR,#0FA00H	; Porta A
	MOVX	@DPTR,A		; Accende LED
	MOV	A,R0		; Recupera tasti
	MOV	R1,A		; Adesso sono Vecchi
	SJMP	mainloop	; Ricomincia da cap
;
	.end
;