; Prova di assembler 8051
; usando AS31
;
; La scheda GPC2 con il suo monitor consente di caricare un programma
; dall'indirizzo 8050h.
; Quell'indirizzo corrisponde all'inizio della ROM (indirizzo 0), quindi
; dopo quell'indirizzo si trovano i vettori di interruzione.
; Al piedino P1.2 sono connessi un LED ed un cicalino (uscita PWM nella
; documentazione).
;
; Per produrre un suono si utilizza un ciclo di ritardo.
; Ogni istruzione 'djnz ...' impiega 24 cicli. L'oscillatore va a 11,0592 MHz.
; Vengono quindi eseguiti 11.059.200 / 24 =  460.800 loop al secondo.
; Se lasciamo a 0 il registro contatore, l'istruzione DJNZ verra' eseguita 256
; volte, quindi avremo in un secondo 460.800 / 256 = 1800 ripetizioni del loop
; ogni secondo. Dato che un ciclo dell'onda quadra prodotta dal beeper sara'
; costituito da una parte ad 1 ed una a 0, quindi da due ripetizioni del loop,
; il cicalino oscilera' a 900 Hz.
;
	.org	8050h
;
on:	cpl	p1.2
on1:	djnz	r0,on1
	djnz	r1,on
;
	sjmp	on
;
	.end
