/***************************************************************************
 *  dmemory.h
 *
 *  Sun Nov 14 10:49:20 2004
 *  Copyright  2004 Ing. Stefano Salvi
 *  Email stefano@salvi.mn.it
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _DMEMORY_H
#define _DMEMORY_H

#ifndef MEMORY_H
#include "memory.h"
#endif
#ifndef _SFRMEMORY_H
#include "sfrmemory.h"
#endif

class DataMemory;
	
class HGPRegister : public HRegister {
	int regnum;	// Numero del registro
	DataMemory *mem;
protected:
	void store ();
public:
	HGPRegister (int r, char *c, DataMemory *m) : HRegister (true, c) { regnum=r, mem=m;};
	virtual int getValue ();
	virtual void setValue (int v);										// Modifica il valore e lo scrive sulla scheda
	virtual HRegister &operator = (int i);						// Modifica il valore ed aggiorna campo associato
};

class DataMemory : public Memory {
	SFRMemory *SFR;
	HGPRegister *Regs [8];
public:
	DataMemory (int c_start, int c_size, SFRMemory *c_SFR);

	virtual void reload ();					// Ricarica l'intero contenuto dello spazio
	virtual void saveValue (int pos);	// Registra il dato sulla scheda
	virtual void redrawIfChanged ();
	virtual void redraw ();
	virtual void setStatus (stat_val s);

	void SFRreload ();						// Aggiorna registri GPR ed SFR
	
	int GetBit (int Bit);
	void SetBit (int Bit,int val);
	unsigned GetTopOfStack (void);
	unsigned char GetRegister (int Reg);
	void SetRegister (int Reg,unsigned char val);
	void SetDDato (unsigned ad,char val);
	unsigned char GetDDato (unsigned ad);
	void Push (char v);
	char Pop (void);
	unsigned GetDPTR (void);
	int getRB () { return SFR->GetPSW() & 0x18; };
	HRegister *getGPreg (int r) { return Regs [r]; };
};

#endif /* _DMEMORY_H */
