/***************************************************************************
 *  editwindow.h
 *
 *  Sun Nov 14 10:49:20 2004
 *  Copyright  2004 Ing. Stefano Salvi
 *  Email stefano@salvi.mn.it
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 

#ifndef EDITWINDOW_H
#define EDITWINDOW_H

#ifndef DIALOGS_H
#include "dialogs.h"
#endif

#ifndef MONWINDOW_H
#include "monwindow.h"
#endif

#ifndef _EDITBUFFER_H
#include "editbuffer.h"
#endif

#ifndef _ERRORINTERFACE_H
#include "errorinterface.h"
#endif

// L'estensione del file assemblato puo' essere '.hex' o '.obj' a seconda
// della versione dell'assemblatore
#define	HEXEXTENSION	".hex"
// #define	HEXEXTENSION	".obj"

class Pcmon;
class EditWindow;
class EditBuffer;
class FindDialog;
class GoToDialog;

class myEdit : public Gtk::TextView {
	EditWindow *parent;

	virtual bool on_button_press_event (GdkEventButton *event);
public :
	myEdit (EditWindow *p);
};

class EditWindow : public monWindow, public errorInterface {
	friend class EditBuffer;
	friend class myEdit;
	friend class ErrorDialog;

	EditWindow *next;
	Pcmon *parent;
  
	myEdit editbox;
	Glib::RefPtr<EditBuffer> cx;
	Gtk::VBox vbox;
	Gtk::HBox status;
	
	Glib::RefPtr<Gtk::ActionGroup> m_refActionGroup;
	Glib::RefPtr<Gtk::UIManager> m_refUIManager;
	Gtk::Menu* m_pMenuPopup;
  
 	Gtk::ScrolledWindow base;
	Gtk::Label Message;

	Glib::RefPtr<Gtk::Action::Action> undoButton;
	Glib::RefPtr<Gtk::Action::Action> redoButton;

	static GoToDialog goToDialog;
	static FindDialog *findDialog;
	ErrorDialog *errorDialog;
	bool uploaded;

	void menuAndToolbarBuild (void);

	virtual bool on_delete_event (GdkEventAny *e);
	virtual bool on_destroy_event (GdkEventAny *e);
	virtual bool on_event(GdkEvent* p1);
	bool mouseDown (GdkEventButton *b);

	void close ();
	char *objName ();
	int testChanged (char *file);
	int doUpload (char *file);
	bool doAssemble ();
	bool realSave (bool force);
	bool realSaveAs ();

protected:
	void lineSelect (int linnum,bool activate);
	void goTo (int offset);

	// Funzioni dei menu'
	void menuSave () { realSave (true); };
	void menuSaveAs () { realSaveAs (); };
	void menuClose ();

	void menuCut ();
	void menuCopy ();
	void menuPaste ();
	void menuDelete ();
	void menuSelAll ();

	// Funzioni undo/redo da GNP
	void menuRedo ();
	void menuUndo ();
	void menuUndoAll ();
	void menuRedoAll ();
	// Fine Funzioni undo/redo da GNP

	void menuFind ();
	void menuFindAgain ();
	void menuGoTo ();

	void menuAssemble ();
	void menuUpload ();
	void menuRun ();
public:
	EditWindow (Pcmon *Parent, EditWindow *Next);
	~EditWindow ();
	int realClose (int single);
	int isChanged ();

	void hasChanged () { uploaded = FALSE; };
 

	void openfile (char *file);
	EditWindow *getNext () { return next; };
	void setNext (EditWindow *n) { next = n;};
	void undoSensitive (bool status) { undoButton -> set_sensitive(status);};
	void redoSensitive (bool status) { redoButton -> set_sensitive(status);};
	void place_cursor_onscreen () { editbox.place_cursor_onscreen (); };
	static char *newChars (std::string const &str);
	void setMessage ();
	virtual void AddError (char *msg);
};

#endif
