/***************************************************************************
 *  sfr.h
 *  Special Function Registers
 *
 *  Sun Nov 14 10:49:20 2004
 *  Copyright  2004 Ing. Stefano Salvi
 *  Email stefano@salvi.mn.it
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 

#ifndef SFR_H
#define SFR_H

#ifndef DIALOGS_H
#include "dialogs.h"
#endif

#ifndef REGISTER_H
#include "register.h"
#endif

#ifndef _MEMORYWINDOW_H
#include "memorywindow.h"
#endif

class Pcmon;
class i8052;
class DataMemory;

class Sfr : public MemoryRegisterWindow {
  
  Register sp;
  Register a;
  Register b;
  Register psw;
  Register dptr;
  Register r0;
  Register r1;
  Register r2;
  Register r3;
  Register r4;
  Register r5;
  Register r6;
  Register r7;

  Gtk::VBox vboxl;
  Gtk::VBox vboxr;
  Gtk::HBox hbox;
  Glib::RefPtr<Gtk::ActionGroup> m_refActionGroup;
  Glib::RefPtr<Gtk::UIManager> m_refUIManager;
  void toolbarBuild (Pcmon *parent);
public :
  Sfr (Pcmon *p, i8052 *proc);
  void redraw ();
};

#endif

//
