/***************************************************************************
 *  symtabs.h
 *
 *  Sun Nov 14 10:49:20 2004
 *  Copyright  2004 Ing. Stefano Salvi
 *  Email stefano@salvi.mn.it
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

static char *regs[] = {       // Data
                /* 0x80 */      "P0",
                /* 0x81 */      "SP",
                /* 0x82 */      "DPL",
                /* 0x83 */      "DPH",
                /* 0x84 */      0,
                /* 0x85 */      0,
                /* 0x86 */      0,
                /* 0x87 */      "PCON",
                /* 0x88 */      "TCON",
                /* 0x89 */      "TMOD",
                /* 0x8A */      "TL0",
                /* 0x8B */      "TL1",
                /* 0x8C */      "TH0",
                /* 0x8D */      "TH1",
                /* 0x8E */      0,
                /* 0x8F */      0,
                /* 0x90 */      "P1",
                /* 0x91 */      0,
                /* 0x92 */      0,
                /* 0x93 */      0,
                /* 0x94 */      0,
                /* 0x95 */      0,
                /* 0x96 */      0,
                /* 0x97 */      0,
                /* 0x98 */      "SCON",
                /* 0x99 */      "SBUF",
                /* 0x9A */      0,
                /* 0x9B */      0,
                /* 0x9C */      0,
                /* 0x9D */      0,
                /* 0x9E */      0,
                /* 0x9F */      0,
                /* 0xA0 */      "P2",
                /* 0xA1 */      0,
                /* 0xA2 */      0,
                /* 0xA3 */      0,
                /* 0xA4 */      0,
                /* 0xA5 */      0,
                /* 0xA6 */      0,
                /* 0xA7 */      0,
                /* 0xA8 */      "IE",
                /* 0xA9 */      0,
                /* 0xAA */      0,
                /* 0xAB */      0,
                /* 0xAC */      0,
                /* 0xAD */      0,
                /* 0xAE */      0,
                /* 0xAF */      0,
                /* 0xB0 */      "P3",
                /* 0xB1 */      0,
                /* 0xB2 */      0,
                /* 0xB3 */      0,
                /* 0xB4 */      0,
                /* 0xB5 */      0,
                /* 0xB6 */      0,
                /* 0xB7 */      0,
                /* 0xB8 */      "IP",
                /* 0xB9 */      0,
                /* 0xBA */      0,
                /* 0xBB */      0,
                /* 0xBC */      0,
                /* 0xBD */      0,
                /* 0xBE */      0,
                /* 0xBF */      0,
                /* 0xC0 */      0,
                /* 0xC1 */      0,
                /* 0xC2 */      0,
                /* 0xC3 */      0,
                /* 0xC4 */      0,
                /* 0xC5 */      0,
                /* 0xC6 */      0,
                /* 0xC7 */      0,
                /* 0xC8 */      0,
                /* 0xC9 */      0,
                /* 0xCA */      0,
                /* 0xCB */      0,
                /* 0xCC */      0,
                /* 0xCD */      0,
                /* 0xCE */      0,
                /* 0xCF */      0,
                /* 0xD0 */      "PSW",
                /* 0xD1 */      0,
                /* 0xD2 */      0,
                /* 0xD3 */      0,
                /* 0xD4 */      0,
                /* 0xD5 */      0,
                /* 0xD6 */      0,
                /* 0xD7 */      0,
                /* 0xD8 */      0,
                /* 0xD9 */      0,
                /* 0xDA */      0,
                /* 0xDB */      0,
                /* 0xDC */      0,
                /* 0xDD */      0,
                /* 0xDE */      0,
                /* 0xDF */      0,
                /* 0xE0 */      "ACC",
                /* 0xE1 */      0,
                /* 0xE2 */      0,
                /* 0xE3 */      0,
                /* 0xE4 */      0,
                /* 0xE5 */      0,
                /* 0xE6 */      0,
                /* 0xE7 */      0,
                /* 0xE8 */      0,
                /* 0xE9 */      0,
                /* 0xEA */      0,
                /* 0xEB */      0,
                /* 0xEC */      0,
                /* 0xED */      0,
                /* 0xEE */      0,
                /* 0xEF */      0,
                /* 0xF0 */      "B",
                /* 0xF1 */      0,
                /* 0xF2 */      0,
                /* 0xF3 */      0,
                /* 0xF4 */      0,
                /* 0xF5 */      0,
                /* 0xF6 */      0,
                /* 0xF7 */      0,
                /* 0xF8 */      0,
                /* 0xF9 */      0,
                /* 0xFA */      0,
                /* 0xFB */      0,
                /* 0xFC */      0,
                /* 0xFD */      0,
                /* 0xFE */      0,
                /* 0xFF */      0,
};

static char *bits[] = {       // Bit 
                /* 0x80 */      "AD0",
                /* 0x81 */      "AD1",
                /* 0x82 */      "AD2",
                /* 0x83 */      "AD3",
                /* 0x84 */      "AD4",
                /* 0x85 */      "AD5",
                /* 0x86 */      "AD6",
                /* 0x87 */      "AD7",
                /* 0x88 */      "IT0",
                /* 0x89 */      "IE0",
                /* 0x8A */      "IT1",
                /* 0x8B */      "IE1",
                /* 0x8C */      "TR0",
                /* 0x8D */      "TF0",
                /* 0x8E */      "TR1",
                /* 0x8F */      "TF1",
                /* 0x90 */      "P1.0",
                /* 0x91 */      "P1.1",
                /* 0x92 */      "P1.2",
                /* 0x93 */      "P1.3",
                /* 0x94 */      "P1.4",
                /* 0x95 */      "P1.5",
                /* 0x96 */      "P1.6",
                /* 0x97 */      "P1.7",
                /* 0x98 */      "RI",
                /* 0x99 */      "TI",
                /* 0x9A */      "RB8",
                /* 0x9B */      "TB8",
                /* 0x9C */      "REN",
                /* 0x9D */      "SM2",
                /* 0x9E */      "SM1",
                /* 0x9F */      "SM0",
                /* 0xA0 */      "A8",
                /* 0xA1 */      "A9",
                /* 0xA2 */      "A10",
                /* 0xA3 */      "A11",
                /* 0xA4 */      "A12",
                /* 0xA5 */      "A13",
                /* 0xA6 */      "A14",
                /* 0xA7 */      "A15",
                /* 0xA8 */      "EX0",
                /* 0xA9 */      "ET0",
                /* 0xAA */      "EX1",
                /* 0xAB */      "ET1",
                /* 0xAC */      "ES",
                /* 0xAD */      0,
                /* 0xAE */      0,
                /* 0xAF */      "EA",
                /* 0xB0 */      "RXD",
                /* 0xB1 */      "TXD",
                /* 0xB2 */      "INT0",
                /* 0xB3 */      "INT1",
                /* 0xB4 */      "T1",
                /* 0xB5 */      "T0",
                /* 0xB6 */      "WR",
                /* 0xB7 */      "RD",
                /* 0xB8 */      "PX0",
                /* 0xB9 */      "PT0",
                /* 0xBA */      "PX1",
                /* 0xBB */      "PT1",
                /* 0xBC */      "PS",
                /* 0xBD */      0,
                /* 0xBE */      0,
                /* 0xBF */      0,
                /* 0xC0 */      0,
                /* 0xC1 */      0,
                /* 0xC2 */      0,
                /* 0xC3 */      0,
                /* 0xC4 */      0,
                /* 0xC5 */      0,
                /* 0xC6 */      0,
                /* 0xC7 */      0,
                /* 0xC8 */      0,
                /* 0xC9 */      0,
                /* 0xCA */      0,
                /* 0xCB */      0,
                /* 0xCC */      0,
                /* 0xCD */      0,
                /* 0xCE */      0,
                /* 0xCF */      0,
                /* 0xD0 */      "P",
                /* 0xD1 */      "PSW.1",
                /* 0xD2 */      "OV",
                /* 0xD3 */      "RS0",
                /* 0xD4 */      "RS1",
                /* 0xD5 */      "F0",
                /* 0xD6 */      "AC",
                /* 0xD7 */      "CY",
                /* 0xD8 */      0,
                /* 0xD9 */      0,
                /* 0xDA */      0,
                /* 0xDB */      0,
                /* 0xDC */      0,
                /* 0xDD */      0,
                /* 0xDE */      0,
                /* 0xDF */      0,
                /* 0xE0 */      "ACC.0",
                /* 0xE1 */      "ACC.1",
                /* 0xE2 */      "ACC.2",
                /* 0xE3 */      "ACC.3",
                /* 0xE4 */      "ACC.4",
                /* 0xE5 */      "ACC.5",
                /* 0xE6 */      "ACC.6",
                /* 0xE7 */      "ACC.7",
                /* 0xE8 */      0,
                /* 0xE9 */      0,
                /* 0xEA */      0,
                /* 0xEB */      0,
                /* 0xEC */      0,
                /* 0xED */      0,
                /* 0xEE */      0,
                /* 0xEF */      0,
                /* 0xF0 */      "B.0",
                /* 0xF1 */      "B.1",
                /* 0xF2 */      "B.2",
                /* 0xF3 */      "B.3",
                /* 0xF4 */      "B.4",
                /* 0xF5 */      "B.5",
                /* 0xF6 */      "B.6",
                /* 0xF7 */      "B.7",
                /* 0xF8 */      0,
                /* 0xF9 */      0,
                /* 0xFA */      0,
                /* 0xFB */      0,
                /* 0xFC */      0,
                /* 0xFD */      0,
                /* 0xFE */      0,
                /* 0xFF */      0,
};

SymTab OpCode::Syms [] = {
	SymTab (regs),
	SymTab (bits)
};
