/***************************************************************************
 *  termdrowing.h
 *
 *  Sun Nov 14 10:49:20 2004
 *  Copyright  2004 Ing. Stefano Salvi
 *  Email stefano@salvi.mn.it
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef TERMDRAWING_H
#define TERMDRAWING_H

class terminal_drawing_area  : public Gtk::DrawingArea
{
  Pango::FontDescription *font;
	
  SigC::Connection cursorTimer;
  int text_h;
  // int text_a;
  int text_w;
  bool curOn;

  int curX, curY;

  char **page;

  static const int nLines = 25;
  static const int nChars = 80;
  static const int border = 5;


  /* Redraw the screen from the backing pixmap */
  bool on_expose_event (GdkEventExpose *event);

  void clearLine (char *line);
  void scroll ();
  bool tick();

public:
  virtual bool gotFocus (GdkEventFocus *e);
  virtual bool lostFocus (GdkEventFocus *e);

  terminal_drawing_area ();
  void tputc (char c);
};

#endif
