/***************************************************************************
 *  dialogs.cc
 *
 *  Sun Nov 14 10:49:20 2004
 *  Copyright  2004 Ing. Stefano Salvi
 *  Email stefano@salvi.mn.it
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include <glib/gmacros.h>
#include <glib.h>
#include <gtkmm.h>
#include <libgnomemm.h>

#include "dialogs.h"

using sigc::mem_fun;


/* ************************************************************************** *
 *                                                                            *
 * LabelField                                                                 *
 *                                                                            *
 * ************************************************************************** */

labelField::labelField (char *label) :
  lfLabel (label)
{
  box.pack_start(lfLabel, false,false,0);
  box.pack_start(testo, false,false,0);

  box.show ();
  lfLabel.show ();
  testo.show ();
}

void labelField::get_text(char *buf, int l)
{
Glib::ustring res;
int len;
    res = testo.get_text();
    len = res.length();
    if (len > l)
    len = 19;
    strncpy (buf,res.data(),len);
    buf [len] = 0;
}

/* ************************************************************************** *
 *                                                                            *
 * MessageDialog                                                              *
 *                                                                            *
 * ************************************************************************** */

Gtk::Dialog *MessageDialog::yesNoCancelDialog = NULL;
Gtk::Label *MessageDialog::yesNoCancelMessage;
Gtk::Button *MessageDialog::YesButton;
Gtk::Button *MessageDialog::NoButton;
Gtk::Button *MessageDialog::CancelButton;

 void MessageDialog::printMessage (Gtk::Label *label,char *message,va_list ap)
{
char msg [256];
  vsnprintf (msg,256,message,ap);
  label -> set_text (msg);

}

int MessageDialog::runDialog (char *title, int nButt, char *Si, char *No, char *Annulla, char *message, va_list ap)
{
int ret;
  if (!yesNoCancelDialog)
  {
	  yesNoCancelDialog = new Gtk::Dialog ();
	  YesButton = yesNoCancelDialog->add_button ("Si",GTK_RESPONSE_ACCEPT);
	  NoButton = yesNoCancelDialog->add_button ("No",GTK_RESPONSE_REJECT);
	  CancelButton = yesNoCancelDialog->add_button ("Annulla",GTK_RESPONSE_CANCEL);
	  yesNoCancelMessage = new Gtk::Label ("Messaggio");
      yesNoCancelDialog -> get_vbox()->add(*yesNoCancelMessage);
	  yesNoCancelMessage -> show ();
	  yesNoCancelDialog -> get_vbox()->show ();
  }

  YesButton -> set_label ((Si && *Si) ? Si : "Si");

  NoButton -> set_label ((No && *No) ? No : "No");
  if (nButt > 1) {
	NoButton -> show ();
  } else {
	NoButton -> hide ();
  }

  CancelButton -> set_label ((Annulla && *Annulla) ? Annulla : "Annulla");
  if (nButt > 2) {
	CancelButton -> show ();
  } else {
	CancelButton -> hide ();
  }
  printMessage (yesNoCancelMessage,message,ap);
  ret =  yesNoCancelDialog->run ();
  yesNoCancelDialog->hide ();
  return ret;
}

/* ************************************************************************** *
 *                                                                            *
 * LabelDialog                                                                *
 *                                                                            *
 * ************************************************************************** */

Gtk::Dialog *LabelDialog::dlog = NULL;
Gtk::Entry *LabelDialog::testo;
Gtk::Label *LabelDialog::Message;
Gtk::Button *LabelDialog::Confirm;

void LabelDialog::buildDialog ()
{
	dlog = new Gtk::Dialog ();
    Confirm = dlog->add_button ("Inserisci",GTK_RESPONSE_ACCEPT);
	dlog->add_button ("Annulla",GTK_RESPONSE_CANCEL);
	Message = new Gtk::Label ("");
    dlog -> get_vbox()->add(*Message);
	Message -> show ();
	testo = new Gtk::Entry ();
	dlog -> get_vbox()->add (*testo);
	testo-> show ();
	dlog -> get_vbox()->show ();
}

char  *LabelDialog::doGetText (char *msg, char *yeslabel)
{
  if (!dlog) {
    buildDialog ();
  }

  testo -> set_text ("");
  Message -> set_text (msg);
  Confirm -> set_label (yeslabel);
  if (dlog -> run () == GTK_RESPONSE_ACCEPT) {
	  dlog->hide ();
	  return strdup (testo -> get_text ().c_str());
  }
  dlog->hide ();
  return NULL;
}
