/***************************************************************************
 *  memory.cc
 *
 *  Sun Nov 14 10:49:20 2004
 *  Copyright  2004 Ing. Stefano Salvi
 *  Email stefano@salvi.mn.it
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "memory.h"

/*
 * Refreshable
 * Interfaccia per gli oggetti di visualizzazione
 */
Updatable dummyU;

void Updatable::redraw ()
{
}

void Updatable::show (unsigned address)
{
}

/*
 * Memory
 * Area di memoria (da specializzare come "data", "Code" o "XData"
 */

Memory::Memory (int c_start, int c_size)
{
	start = c_start;
	size = c_size;
	data = new unsigned char [size];
	r = &dummyU;
}

void Memory::SetDato (unsigned ad,char val)
{
	ad -= start;
	if (ad < (unsigned)size) {
		data [ad] = val & 0xff; 
	}
	if (status == stopped) {
		redraw (); 
	} else {
		toRedraw = true;
	}
}

unsigned char Memory::GetDato (unsigned ad)
{ 
	ad -= start;
	return (ad < (unsigned)size) ? data [ad] : 0;
}
