/***************************************************************************
 *  symtab.cc
 *
 *  Sun Nov 14 10:49:20 2004
 *  Copyright  2004 Ing. Stefano Salvi
 *  Email stefano@salvi.mn.it
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "symtab.h"

// ************************************************************************
// * Class SymTab
// ************************************************************************

char *SymTab::GetCode (char *s,unsigned char *p)
{
char sym [10];
int i;
	// Copia il simbolo nella variabile locale, in maiuscolo
	for (i = 0;i < 9 && *s > ' ' && *s != ',';i ++) {
		sym [i] = toupper (*s++);
	}
	sym [i] = 0;

	for (i = 0;i < 128;i ++) {
		if (Syms [i] && !strcmp (sym,Syms [i])) {
			*p = i + 128;
			break;
		}
	}

	if (i >= 128) {
		return NULL;
	}

	return s;
}

void SymTab::GetName (char *s,unsigned char pos)
{
	if (pos & 0x80) {       // Possibile simbolo
		if (Syms [pos & 0x7f]) {
			strcpy (s,Syms [pos & 0x7f]);
		} else {
			sprintf (s,"0%02xH",pos);
		}
	} else {       // Numero
		sprintf (s,"0%02xH",pos);
	}
}
