/***************************************************************************
 *            xmemorypanel.cc
 *
 *  Sun Nov 14 10:49:20 2004
 *  Copyright  2004 Ing. Stefano Salvi
 *  Email stefano@salvi.mn.it
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include <glib/gmacros.h>
#include <glib.h>
#include <gtkmm.h>
#include <libgnomemm.h>
 
#include "xmemorypanel.h"

#ifndef XMEMORY_H
#include "xmemory.h"
#endif

bool XMemoryPanel::on_expose_event (GdkEventExpose *event)
{
    // Se un'area non e' stata letta, la legge
	((XDataMemory*) data) ->checkRange (yOffs * 16 + data -> getStart (), 
		((curH - border)/text_h + yOffs) * 16 + data -> getStart ());
 
    return MemoryPanel::on_expose_event (event);
}

void XMemoryPanel::goTo (unsigned address)
{
	if (address >= data->getStart() && address < data->getEnd()) {
		curY = (address - data -> getStart ()) / 16;
		// Visualizza la posizione del cursore
		if (curY < yOffs) {
			VAdj->set_value (curY);
		} else if (curY >= yOffs + (get_height () - border)/text_h) {
			VAdj->set_value (curY - (get_height () - border)/text_h / 2);
		}
		redraw ();
	}
}
